﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RaszteresAbrakRajzolasa
{
    public partial class FormFő : Form
    {
        //saját rutinok: ---------------------------------------------------------------------
        void Téglalap(int x0, int y0, int dx, int dy, Color szín)
        {
            Bitmap bm = (Bitmap)pictureBoxKép.Image;//bm a picBxKep Image-re mutat
            for (int x = x0; x < Math.Min(x0+dx,pictureBoxKép.Width); ++x)
            {
                for (int y = y0; y < Math.Min(y0+dy,pictureBoxKép.Height); ++y)
                {
                    //Console.Write("({0},{1})", x, y);
                    bm.SetPixel(x, y, szín);
                }
                //Console.WriteLine();
            }
            //pictureBoxKép.Refresh();
        }
        void Kitöltött()
        {
            Console.WriteLine("{0},{1}", pictureBoxKép.Width, pictureBoxKép.Height);
            Téglalap(0, 0, pictureBoxKép.Width, pictureBoxKép.Height, Color.Red);
            pictureBoxKép.Refresh();
        }
        void Pepita(int dx, int dy)
        {
            int maxX = pictureBoxKép.Width; int maxY = pictureBoxKép.Height;
            Bitmap bm = (Bitmap)pictureBoxKép.Image;//bm a picBxKep Image-re mutat
            bool pirosE=true;
            Color szín=Color.Red;
            //első sor:
            for (int x0 = 0; x0 < maxX; x0 += dx)
            {
                if (pirosE) szín = Color.Red; else szín = Color.White;
                Téglalap(x0, 0, dx, dy, szín);
                pirosE = !pirosE;
            }
            //többi sor:
            for (int y0 = dy; y0 < maxY; y0 += dy)
            {
                for (int x0 = 0; x0 < maxX; x0 += dx)
                {
                    //Nem jó:
                    //pirosE = bm.GetPixel(x0, y0 - dy) == Color.Red;
                    pirosE = bm.GetPixel(x0, y0 - dy) == Color.FromArgb(255, 0, 0);
                    pirosE = !pirosE;
                    if (pirosE) szín = Color.Red; else szín = Color.White;
                    Téglalap(x0, y0, dx, dy, szín);
                }
            }
            pictureBoxKép.Refresh();
        }
        public void Zajos()
        {
            Bitmap bm = (Bitmap)pictureBoxKép.Image;//bm a picBxKep Image-re mutat
            Random rnd = new Random();

            for (int y = 0; y < bm.Height; ++y)
            {
                for (int x = 0; x < bm.Width; ++x)
                {
                    if (rnd.Next() % 2 == 0)
                        bm.SetPixel(x, y, Color.White);
                    else
                        bm.SetPixel(x, y, Color.Red);
                }
            }
            pictureBoxKép.Refresh();//a rajzolás eredményét megjeleníti a pictureBoxKép-ben
        }

        public FormFő()
        {
            InitializeComponent();
        }

        //eseménykezelők: --------------------------------------------------------------------
        private void buttonKilép_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void buttonKirajzol_Click(object sender, EventArgs e)
        {
            /* a listBox kijelöltségének tesztelése:
            if (listBoxKépek.SelectedItem != null)//van kijelölés
            {
                MessageBox.Show("Item:"+listBoxKépek.SelectedItem.ToString()+
                                " Index:"+listBoxKépek.SelectedIndex.ToString()+
                                " Text:"+listBoxKépek.Text);
            }
            */
            switch (listBoxKépek.SelectedIndex)
            {
                case 0: Kitöltött(); break;
                case 1: Pepita(5,5); break;
                case 2: Pepita(50, 50); break;
                case 3: Zajos();  break;
            }
        }

        private void FormFő_Load(object sender, EventArgs e)
        {
            pictureBoxKép.Image = new Bitmap(pictureBoxKép.Width, pictureBoxKép.Height);

        }

        private void pictureBoxKép_SizeChanged(object sender, EventArgs e)
        {
            pictureBoxKép.Image=new Bitmap(pictureBoxKép.Width, pictureBoxKép.Height);
            buttonKirajzol_Click(sender,e);
        }
    }
}
